/* sf16r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__16 = 16;

/* Subroutine */ int sf16r_c(real *x, real *ber, real *bei, real *aker,
        real *akei, integer *ierr)
{
    /* Initialized data */

    static real ten = 10.f;
    static real e2[9] = { -2.43e-8f,7.5e-8f,5.929e-7f,1.6431e-6f,-7.2e-9f,
            -5.18006e-5f,-7.031241e-4f,-.008838834f,0.f };
    static real sys005 = 1.570796f;
    static real sys011 = .3926991f;
    static real sys003 = 6.283185f;
    static real sys001 = 3.141593f;
    static real sys039 = .5772157f;
    static real sys029 = .7071068f;
    static real sys059 = 3.4e38f;
    static real zmax = 2040.f;
    static real one = 1.f;
    static real zero = 0.f;
    static real half = .5f;
    static real c1[9] = { 5.160705e-5f,-.004898713f,.2597773f,-7.242257f,
            93.85967f,-470.9503f,678.1684f,-156.25f,1.f };
    static real c2[9] = { 4.4913e-6f,-5.444243e-4f,.03842883f,-1.496334f,
            28.96903f,-240.2808f,678.1684f,-434.0278f,25.f };
    static real c3[9] = { 1.54363e-5f,-.001806478f,.1222087f,-4.518746f,
            81.95248f,-623.0137f,1548.485f,-795.7176f,25.f };
    static real c4[9] = { 1.216111e-6f,-1.797628e-4f,.01593801f,-.8061529f,
            21.21235f,-255.0972f,1153.828f,-1412.851f,234.375f };
    static real e1[9] = { 4.92e-8f,1.452e-7f,1.35e-8f,-1.6192e-6f,
            -1.12207e-5f,-5.17869e-5f,7e-10f,.008838835f,1.f };

    /* Builtin functions */
    double log(doublereal), sin(doublereal), cos(doublereal), exp(doublereal),
             sqrt(doublereal);

    /* Local variables */
    static integer i__;
    static real s, t, z__;
    extern /* Subroutine */ int utsf10_c(integer *, integer *);
    static real b1, b2, b3, b4, r1, r2, z4, dc, de, ds, sm, tm, zi, dcm, arg, 
            con, dsm, dsq, zim, zsq;

    *ierr = 0;
    z__ = abs(*x);
    if (z__ > ten) {
        goto L30;
    }
    if (z__ == zero) {
        goto L20;
    }
    z__ /= ten;
    zsq = z__ * z__;
    z4 = zsq * zsq;
    b1 = c1[0];
    b2 = c2[0];
    b3 = c3[0];
    b4 = c4[0];
    for (i__ = 2; i__ <= 9; ++i__) {
        b1 = b1 * z4 + c1[i__ - 1];
        b2 = b2 * z4 + c2[i__ - 1];
        b3 = b3 * z4 + c3[i__ - 1];
        b4 = b4 * z4 + c4[i__ - 1];
/* L10: */
    }
    *ber = b1;
    *bei = zsq * b2;
    if (*x < zero) {
        goto L60;
    }
    r1 = zsq * b3;
    r2 = z4 * b4;
    con = (real)log((real)(*x * half)) + sys039;
    *akei = -sys005 * half * *ber + (r1 - *bei * con);
    *aker = sys005 * half * *bei - (r2 + *ber * con);
    goto L90;
L20:
    *ber = one;
    *bei = zero;
    *akei = -half * sys005;
    *aker = sys059;
    goto L90;
L30:
    if (z__ > zmax) {
        goto L50;
    }
    zi = ten / z__;
    zim = -zi;
    s = e1[0];
    sm = s;
    t = e2[0];
    tm = t;
    for (i__ = 2; i__ <= 9; ++i__) {
        s = s * zi + e1[i__ - 1];
        t = t * zi + e2[i__ - 1];
        sm = sm * zim + e1[i__ - 1];
        tm = tm * zim + e2[i__ - 1];
/* L40: */
    }
    arg = z__ * sys029;
    ds = (real)sin((real)(arg - sys011));
    dc = (real)cos((real)(arg - sys011));
    dsm = (real)sin((real)(arg + sys011));
    dcm = (real)cos((real)(arg + sys011));
    de = (real)exp(arg);
    dsq = (real)sqrt((real)(sys003 * z__));
    *ber = de * (s * dc - t * ds) / dsq;
    *bei = de * (t * dc + s * ds) / dsq;
    if (*x < zero) {
        goto L60;
    }
    *akei = sys001 * (tm * dcm - sm * dsm) / (de * dsq);
    *aker = sys001 * (sm * dcm + tm * dsm) / (de * dsq);
    goto L90;
L50:
    *ber = zero;
    *bei = zero;
    *ierr = 66;
    if (*x < zero) {
        goto L70;
    }
    *akei = zero;
    *aker = zero;
    goto L80;
L60:
    *ierr = 1;
L70:
    *akei = sys059;
    *aker = sys059;
    if (*ierr == 0) {
        goto L90;
    }
L80:
    utsf10_c(ierr, &c__16);
L90:
    return 0;
} /* sf16r_c */
